



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++堆栈问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++堆栈问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-24 09:14:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>编写C++中的两个类 一个只能在栈中分配空间 一个只能在堆中分配。</p>
<div>解答：</div>
<div>（1）代码如下</div>
<div>
<div>
<div>
</div>
</div>
</div>
<div>（2）堆栈分配内存的介绍</div>
<div>
<p>一、一个经过编译的C/C++的程序占用的内存分成以下几个部分：<br />1、栈区（stack）：由编译器自动分配和释放 ，存放函数的参数值、局部变量的值等，甚至函数的调用过程都是用栈来完成。其操作方式类似于数据结构中的栈。<br />2、堆区（heap） ：一般由程序员手动申请以及释放， 若程序员不释放，程序结束时可能由OS回收 。注意它与数据结构中的堆是两回事，分配方式类似于链表。<br />3、全局区（静态区）（static）：全局变量和静态变量的存储是放在一块的，初始化的全局变量和静态变量在一块区域， 未初始化的全局变量和未初始化的静态变量在相邻的另一块区域。程序结束后由系统释放空间。 <br />4、文字常量区：常量字符串就是放在这里的。 程序结束后由系统释放空间。<br />5、程序代码区：存放函数体的二进制代码。</p>
<p>下面的例子可以完全展示不同的变量所占的内存区域：</p>
<div>
<div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">//main.cpp<br />
int a = ; 全局初始化区<br />
char *p1; 全局未初始化区<br />
main(){<br />
int b; //栈中<br />
char s[] = "abc"; //栈中<br />
char *p2; //栈中<br />
char *p3 = ""; //123456/0在常量区，p3在栈上<br />
static int c =； //全局（静态）初始化区

//以下分配得到的10和20字节的区域就在堆区<br />
p1 = (char *)malloc();<br />
p2 = new char[];//<br />
(char *)malloc();strcpy(p1, "");<br />
 //123456/0放在常量区，编译器可能会将它与p3所指向的"123456"优化成一个地方。<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
</div>
<p>二、栈（stack）和堆（heap）具体的区别。</p></div>
<p>1、在申请方式上<br />栈（stack）: 现在很多人都称之为堆栈，这个时候实际上还是指的栈。它由编译器自动管理，无需我们手工控制。 例如，声明函数中的一个局部变量 int b 系统自动在栈中为b开辟空间；在调用一个函数时，系统自动的给函数的形参变量在栈中开辟空间。<br />堆（heap）: 申请和释放由程序员控制，并指明大小。容易产生memory leak。<br />在C中使用malloc函数。<br />如：p1 = (char *)malloc(10);<br />在C++中用new运算符。<br />如：p2 = new char[20];//(char *)malloc(10);<br />但是注意p1本身在全局区，而p2本身是在栈中的，只是它们指向的空间是在堆中。</p>
<p>2、申请后系统的响应上<br />栈（stack）:只要栈的剩余空间大于所申请空间，系统将为程序提供内存，否则将报异常提示栈溢出。<br />堆（heap）: 首先应该知道操作系统有一个记录空闲内存地址的链表，当系统收到程序的申请时， 会遍历该链表，寻找第一个空间大于所申请空间的堆结点，然后将该结点从空闲结点链表中删除，并将该结点的空间分配给程序。另外，对于大多数系统，会在这块内存空间中的首地址处记录本次分配的大小，这样，代码中的delete或free语句才能正确的释放本内存空间。另外，由于找到的堆结点的大小不一定正好等于申请的大小，系统会自动的将多余的那部分重新放入空闲链表中。</p>
<p>3、申请大小的限制<br />栈（stack）:在Windows下,栈是向低地址扩展的数据结构，是一块连续的内存的区域。这句话的意思是栈顶的地址和栈的最大容量是系统预先规定好的，在WINDOWS下，栈的大小是2M（也有的说是1M，总之是一个编译时就确定的常数），如果申请的空间超过栈的剩余空间时，将提示overflow。因此，能从栈获得的空间较小。 例如，在VC6下面，默认的栈空间大小是1M（好像是，记不清楚了）。当然，我们可以修改：打开工程，依次操作菜单如下：Project-&gt;Setting-&gt;Link，在Category 中选中Output，然后在Reserve中设定堆栈的最大值和commit。<br /><strong>注意</strong>：reserve最小值为4Byte；commit是保留在虚拟内存的页文件里面，它设置的较大会使栈开辟较大的值，可能增加内存的开销和启动时间。</p>
<p>堆（heap）: 堆是向高地址扩展的数据结构，是不连续的内存区域（空闲部分用链表串联起来）。正是由于系统是用链表来存储空闲内存，自然是不连续的，而链表的遍历方向是由低地址向高地址。一般来讲在32位系统下，堆内存可以达到4G的空间，从这个角度来看堆内存几乎是没有什么限制的。由此可见，堆获得的空间比较灵活，也比较大。</p>
<p>4、分配空间的效率上<br />栈（stack）:栈是机器系统提供的数据结构，计算机会在底层对栈提供支持：分配专门的寄存器存放栈的地址，压栈出栈都有专门的指令执行，这就决定了栈的效率比较高。但程序员无法对其进行控制。<br />堆（heap）:是C/C++函数库提供的，由new或malloc分配的内存，一般速度比较慢，而且容易产生内存碎片。它的机制是很复杂的，例如为了分配一块内存，库函数会按照一定的算法（具体的算法可以参考数据结构/操作系统）在堆内存中搜索可用的足够大小的空间，如果没有足够大小的空间（可能是由于内存碎片太多），就有可能调用系统功能去增加程序数据段的内存空间，这样就有机会分到足够大小的内存，然后进行返回。这样可能引发用户态和核心态的切换，内存的申请，代价变得更加昂贵。显然，堆的效率比栈要低得多。</p>
<p>5、堆和栈中的存储内容<br />栈（stack）:在函数调用时，第一个进栈的是主函数中子函数调用后的下一条指令（子函数调用语句的下一条可执行语句）的地址，然后是子函数的各个形参。在大多数的C编译器中，参数是由右往左入栈的，然后是子函数中的局部变量。注意：静态变量是不入栈的。 当本次函数调用结束后，局部变量先出栈，然后是参数，最后栈顶指针指向最开始存的地址，也就是主函数中子函数调用完成的下一条指令，程序由该点继续运行。<br />堆（heap）:一般是在堆的头部用一个字节存放堆的大小，堆中的具体内容有程序员安排。</p>
<p>6、存取效率的比较<br />这个应该是显而易见的。拿栈上的数组和堆上的数组来说：</p>
<div>
<div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">void main()<br />
{<br />
    int arr[]={,,,,};<br />
    int *arr1;<br />
    arr1=new int[];<br />
    for (int j=;j&lt;=;j++)   {   arr1[j]=j+;   }<br />
    int a=arr[];<br />
    int b=arr1[];<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
</div>
</div>
<p>上面代码中，arr1（局部变量）是在栈中，但是指向的空间确在堆上，两者的存取效率，当然是arr高。因为arr[1]可以直接访问，但是访问arr1[1]，首先要访问数组的起始地址arr1，然后才能访问到arr1[1]。</p>
<p>总而言之，言而总之：<br />堆和栈的区别可以用如下的比喻来看出：<br />使用栈就象我们去饭馆里吃饭，只管点菜（声明变量）、付钱、和吃（使用），吃饱了就走，不必理会切菜、洗菜等准备工作和洗碗、刷锅等扫尾工作，他的好处是快捷，但是自由度小。<br />使用堆就象是自己动手做喜欢吃的菜肴，比较麻烦，但是比较符合自己的口味，而且自由度大。</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g3o5lq.html">【Eclipse】 Eclipse 中JPEGEncodeParam 错误波浪线问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1dz22q.html">【代码笔记】iOS-竖状图</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o6rnl8.html">PHP中的 extends与implements 区别 &lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vrrno8.html">Android 使用Telephony API</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjxd3d9.html">smartPtr指针的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydl322q.html">JavaScript clearInterval定时器失效原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdppjmxq.html">HashMap的遍历和排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1d5ezq.html">Gentoo&colon; &excl;&excl;&excl; existing preserved libs问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j27xv8.html">Java学习笔记--动态代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gxjo6q.html">mpvue开发小程序记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r14558.html">百度地图 android SDKv2&period;2&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllgnw6q.html">利用ant脚本 自动构建svn增量&sol;全量 系统程序升级包【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllgxwxq.html">WeakReference 在android中的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/902vv4nq.html">Django&lowbar;博客项目 引入外部js文件内含模板语法无法正确获取值得说明和处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vv2v5q.html">Build 2016上一些令人兴奋的东西</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnndej2q.html">CBV流程之View源码解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql13r0k9.html">在 macOS 中激活 Astash Professional</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e4jkg9.html">Orchard运用  - 整合多说评论插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q441pw5q.html">解决：kali linux 在vmware 虚拟机中使用bridge模式上网的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1pj4p2q.html">VMware12 download</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2j1oex8.html">中国电信中兴F460光猫破解及路由级联设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpv6k7q.html">【一天一道LeetCode】&num;83&period; Remove Duplicates from Sorted List</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me4ozoq.html">C&num;之DirectoryInfo操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k6m549.html">outlook邮箱邮件与企业邮箱同步&lpar;outlook本地文件夹邮件，web邮箱里没有&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjz1328.html">quartz实现定时功能实例详解&lpar;servlet定时器配置方法&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpgjp69.html">&lbrack;Ext&period;Net&rsqb;客户关系管理系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gevpj78.html">【一天一道LeetCode】&num;35&period; Search Insert Position</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj31p69.html">【Matlab编程】Matlab及Java小时钟</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1j2ldq.html">网站开发进阶&lpar;二十一&rpar;Angular项目信息错位显示问题解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj3n4e9.html">传统定时器技术  Timer and TimerTask</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
